import u from "../../node_modules/axios/lib/axios.ts";
import { LOGIN_URL as a, SMS_URL as o } from "./url.ts";
import { message as c } from "ant-design-vue";
import p from "../common/client.ts";
import m from "../common/logout.ts";
const s = u.create({
  baseURL: "/api/misengine",
  timeout: 5e4
  // headers: { 'Content-Type': 'application/json;charset=utf-8' }
});
s.interceptors.request.use(
  (t) => {
    const { url: e } = t, r = e.split("?")[0];
    return [a.LOGIN].includes(r) ? t.headers.Authorization = `Basic ${p}` : [
      a.REGISTER,
      a.RESET,
      o.IMAGE_CODE,
      o.SMS_REGISTER,
      o.SMS_RESET
    ].includes(r) || (t.headers.Authorization = `Bearer ${localStorage.getItem("access_token")}`), t;
  },
  (t) => Promise.reject(t)
);
s.interceptors.response.use(
  (t) => {
    if (t.request.responseType === "blob")
      return t.data;
    const e = t.data, { code: r, msg: n, data: i } = e;
    return r === 2e3 ? Promise.resolve(i) : r === 4001 ? (c.error(n || "系统出错"), Promise.reject(new Error(n || "Error"))) : Promise.reject(t.data);
  },
  (t) => {
    let e = "";
    const r = t.response.status;
    switch (r) {
      case 400:
        e = "请求错误(400)";
        break;
      case 401:
        e = "登录过期，请重新登录！", m();
        break;
      case 403:
        e = "权限不足";
        break;
      case 404:
        e = "请求出错(404)";
        break;
      case 408:
        e = "请求超时(408)";
        break;
      case 500:
        e = "服务器错误(500)";
        break;
      case 501:
        e = "服务未实现(501)";
        break;
      case 502:
        e = "网络错误(502)";
        break;
      case 503:
        e = "服务不可用(503)";
        break;
      case 504:
        e = "网络超时(504)";
        break;
      case 505:
        e = "HTTP版本不受支持(505)";
        break;
      default:
        e = `连接出错(${t.response.status})!`;
    }
    return c.error(e), console.log("message :>> ", e), Promise.reject({ msg: e, states: r });
  }
);
const l = (t, e) => s.get(t, { params: e }), b = async (t, e) => await s.post(t, e), d = async (t, e) => await s.delete(t, e), g = async (t, e) => await s.put(t, e), k = async (t, e) => await s.post(t, e, { responseType: "blob" }), E = async (t, e) => await s.get(t, { params: e, responseType: "blob" }), y = {
  // async get<T extends AxiosRequestConfig<any>, M>(url: string, params?: T): AxiosPromise<M> {
  //   return await service.get(url, { params })
  // },
  // async post<M, T = any>(url: string, data?: T): AxiosPromise<M> {
  //   return await service.post(url, data)
  // },
  // async put<T, M>(url: string, data: T): AxiosPromise<M> {
  //   return await service.put(url, data)
  // },
  // async postDownload(url, data) {
  //   return await service.post(url, data, { responseType: 'blob' })
  // },
  // async getDownload(url, params) {
  //   return await service.get(url, { params, responseType: 'blob' })
  // },
  get: l,
  post: b,
  delete: d,
  put: g,
  postDownload: k,
  getDownload: E
};
export {
  y as default
};
