import e from "../Xhttp.ts";
import { DATA_RULE_URL as a } from "../url.ts";
const l = {
  // 获取规则数据列表
  async getRules(t) {
    return await e.get(a.LIST, t);
  },
  // 添加数据规则
  async addRule(t) {
    return await e.post(a.ADD, t);
  },
  // 修改数据规则
  async updateRule(t, r) {
    return await e.put(a.UPDATE(t), r);
  },
  // 删除数据规则
  async deleteRule(t) {
    return await e.delete(a.DELETE(t));
  },
  // 获取规则详情
  async getRule(t) {
    return await e.get(a.GET(t));
  },
  // 获取支持的运算符列表
  async getSupportRelation() {
    return await e.get("/dataRule/supportRelation");
  }
};
export {
  l as default
};
