import { defineComponent as V, ref as _, onMounted as w, resolveComponent as s, openBlock as p, createBlock as v, unref as l, withCtx as f, createVNode as D, isRef as T, createElementBlock as j, Fragment as G, renderList as N, createTextVNode as O, toDisplayString as E } from "vue";
import H from "../../BaseFields/index.ts";
import { parseDict as L } from "../../../../utils/dict.ts";
import { keyBy as R } from "lodash";
const P = /* @__PURE__ */ V({
  name: "CheckboxField",
  __name: "index",
  props: {
    options: { type: Object, required: !0 },
    formData: { type: Object, required: !0 }
  },
  setup(b, { expose: x }) {
    const m = b, { label: y, field: c, required: g, readonly: k, placeholder: B, inputValue: r, hide: q, eventBus: C } = H(m), u = _([]), i = _({}), F = () => {
      d(r.value);
    };
    w(() => {
      A();
    });
    async function A() {
      const { dict: e } = m.options;
      u.value = await L(e), i.value = h(u.value);
    }
    function h(e) {
      let t = R(e, "value");
      if (Array.isArray(e) && e.length > 0)
        for (let a = 0; a < e.length; a++) {
          const { children: o } = e[a];
          o && (t = { ...t, ...h(o) });
        }
      return t;
    }
    function d(e) {
      r.value = e;
      let t = [];
      Array.isArray(e) && (t = e.map((a) => {
        var o;
        return ((o = i.value[a]) == null ? void 0 : o.data) || i.value[a];
      })), C.emit("change", { field: c, value: e, data: t });
    }
    return x({ reset: () => {
      d(null);
    }, field: c, setValue: d }), (e, t) => {
      const a = s("a-checkbox"), o = s("a-checkbox-group"), I = s("GTField");
      return p(), v(I, {
        label: l(y),
        field: l(c),
        required: l(g),
        hide: l(q)
      }, {
        default: f(() => [
          D(o, {
            value: l(r),
            "onUpdate:value": t[0] || (t[0] = (n) => T(r) ? r.value = n : null),
            placeholder: l(B),
            onChange: F,
            "allow-clear": "",
            disabled: l(k)
          }, {
            default: f(() => [
              (p(!0), j(G, null, N(l(u), (n, M) => (p(), v(a, {
                value: n.value,
                key: M
              }, {
                default: f(() => [
                  O(E(n.label), 1)
                ]),
                _: 2
              }, 1032, ["value"]))), 128))
            ]),
            _: 1
          }, 8, ["value", "placeholder", "disabled"])
        ]),
        _: 1
      }, 8, ["label", "field", "required", "hide"]);
    };
  }
});
export {
  P as default
};
