import { defineComponent as q, computed as d, ref as F, onMounted as j, resolveComponent as f, openBlock as B, createBlock as g, unref as t, withCtx as G, createVNode as z, isRef as H } from "vue";
import M from "../../BaseFields/index.ts";
import n from "../../../../../node_modules/dayjs/dayjs.min.ts";
import "../../../../../node_modules/dayjs/locale/zh-cn.ts";
const I = /* @__PURE__ */ q({
  name: "DateField",
  __name: "index",
  props: {
    options: { type: Object, required: !0 },
    formData: { type: Object, required: !0 }
  },
  setup(v, { expose: h }) {
    n.locale("zh-cn");
    const a = v, { label: _, field: s, required: b, readonly: D, placeholder: w, inputValue: m, hide: x, setValue: u } = M(a), C = d(() => !a.options.hideClear), O = d(() => a.options.showTime), r = d(() => {
      const { mode: e } = a.options;
      return e === "year-month" ? "month" : ["", void 0, null].includes(e) ? "date" : e;
    }), c = d(() => {
      const { maxDate: e, monthOffset: l } = a.options;
      if (e)
        return e;
      const i = r.value === "date" ? "month" : r.value;
      return l ? n().add(l[1], i).valueOf() : null;
    }), p = d(() => {
      const { minDate: e, monthOffset: l } = a.options;
      if (e)
        return e;
      const i = r.value === "date" ? "month" : r.value;
      return l ? n().add(-l[0], i).valueOf() : null;
    }), o = F();
    j(() => {
      m.value && (o.value = n(m.value));
    });
    const k = () => {
      const e = o.value ? n(o.value).valueOf() : null;
      u(e);
    }, y = (e) => (e = n(e).valueOf(), c.value && p.value ? e && (e < p.value || e > c.value) : !1);
    return h({ reset: () => {
      o.value = void 0, u(null);
    }, field: s, setValue: u }), (e, l) => {
      const i = f("a-date-picker"), T = f("GTField");
      return B(), g(T, {
        label: t(_),
        field: t(s),
        required: t(b),
        hide: t(x)
      }, {
        default: G(() => [
          z(i, {
            style: { width: "100%" },
            picker: t(r),
            allowClear: t(C),
            value: t(o),
            "onUpdate:value": l[0] || (l[0] = (V) => H(o) ? o.value = V : null),
            "disabled-date": y,
            placeholder: t(w),
            onChange: k,
            showTime: t(O),
            disabled: t(D)
          }, null, 8, ["picker", "allowClear", "value", "placeholder", "showTime", "disabled"])
        ]),
        _: 1
      }, 8, ["label", "field", "required", "hide"]);
    };
  }
});
export {
  I as default
};
