import { defineComponent as I, computed as m, ref as y, onMounted as L, resolveComponent as c, openBlock as v, createBlock as w, unref as t, withCtx as p, createVNode as B, isRef as D, createElementBlock as M, Fragment as S, renderList as W, createTextVNode as z, toDisplayString as H } from "vue";
import J from "../../BaseFields/index.ts";
import { parseDict as K } from "../../../../utils/dict.ts";
import { isNumber as P } from "lodash";
const $ = /* @__PURE__ */ I({
  name: "NumberWithUnitField",
  __name: "index",
  props: {
    options: { type: Object, required: !0 },
    formData: { type: Object, required: !0 }
  },
  setup(N, { expose: V }) {
    const n = N, {
      label: q,
      required: k,
      readonly: _,
      placeholder: U,
      inputValue: o,
      hide: T,
      reset: j,
      eventBus: h,
      formRecordData: s
    } = J(n), f = m(() => n.options.unitField.field).value, a = m(() => n.options.valueField.field).value, G = m(() => !n.options.hideClear), b = n.options.precision, u = y(void 0), r = y([]), F = () => {
      C(o.value);
    }, O = () => {
      g(u.value);
    };
    L(async () => {
      const { options: e } = n;
      r.value = await K(e.dict) || [];
      let l = null;
      [void 0, null, ""].includes(s[a]) ? [void 0, null, ""].includes(e.default) || (l = e.default) : l = s[a], l !== null && C(l);
      let i = r.value.length !== 0 ? r.value[0].value : "";
      [void 0, null, ""].includes(s[f]) ? [void 0, null, ""].includes(e.unitDefault) || (i = e.unitDefault) : i = s[f], i !== "" && g(i);
    });
    const C = (e) => {
      P(e) || (e = parseFloat(e)), b && (e = parseFloat(e.toFixed(b))), isNaN(e) && (e = void 0), o.value = e, h.emit("change", { field: a, value: e });
    }, g = (e) => {
      u.value = e, h.emit("change", { field: f, value: e });
    };
    return V({ reset: j, field: a }), (e, l) => {
      const i = c("a-select-option"), R = c("a-select"), A = c("a-input-number"), E = c("GTField");
      return v(), w(E, {
        label: t(q),
        field: t(a),
        required: t(k),
        hide: t(T)
      }, {
        default: p(() => [
          B(A, {
            style: { width: "100%" },
            value: t(o),
            "onUpdate:value": l[1] || (l[1] = (d) => D(o) ? o.value = d : null),
            placeholder: t(U),
            allowClear: t(G),
            onBlur: F,
            onChange: F,
            disabled: t(_),
            controls: !1
          }, {
            addonAfter: p(() => [
              B(R, {
                value: t(u),
                "onUpdate:value": l[0] || (l[0] = (d) => D(u) ? u.value = d : null),
                style: { width: "80px" },
                disabled: t(_),
                onChange: O
              }, {
                default: p(() => [
                  (v(!0), M(S, null, W(t(r), ({ label: d, value: x }) => (v(), w(i, {
                    key: x,
                    value: x
                  }, {
                    default: p(() => [
                      z(H(d), 1)
                    ]),
                    _: 2
                  }, 1032, ["value"]))), 128))
                ]),
                _: 1
              }, 8, ["value", "disabled"])
            ]),
            _: 1
          }, 8, ["value", "placeholder", "allowClear", "disabled"])
        ]),
        _: 1
      }, 8, ["label", "field", "required", "hide"]);
    };
  }
});
export {
  $ as default
};
