import { customAlphabet as q } from "../../node_modules/nanoid/index.browser.ts";
import { message as A } from "ant-design-vue";
import { cloneDeep as E } from "lodash";
let T = !1, p = "", y = [], b = [];
const m = () => q("abcdefghijklmnopqrstuvwxyz", 1)() + q("abcdefghijklmnopqrstuvwxyz1234567890", 9)(), w = {
  LonLatField: [
    "lonField",
    "latField",
    "pcodeField",
    "ccodeField",
    "fcodeField",
    "pnameField",
    "cnameField",
    "fnameField",
    "addressField"
  ],
  NumberWithUnitField: ["valueField", "unitField"],
  DateRangeField: ["startField", "endField"],
  AdminField: ["field", "subField"]
};
function _(e, i, l) {
  var a;
  if (Array.isArray(e))
    e.forEach((r) => {
      _(r, i, l);
    });
  else {
    const r = (a = e == null ? void 0 : e.options) == null ? void 0 : a.children;
    Array.isArray(r) ? r.forEach((d) => {
      l && d.children ? d.children.forEach((t) => {
        v(t, i, l);
      }) : v(d, i, l);
    }) : v(e, i, l);
  }
}
function v(e, i, l) {
  var a, r, d;
  if ((a = e == null ? void 0 : e.type) != null && a.endsWith("Field")) {
    const t = g(e, i);
    l ? t.forEach(({ field: o, label: f }) => {
      y.includes(o) || b.push(f);
    }) : (D(t, i), k(t, i), T && U(t, i)), R(t, i);
  } else
    (r = e == null ? void 0 : e.type) != null && r.endsWith("SubForm") ? x(e, i, l) : (d = e == null ? void 0 : e.options) != null && d.children && _(e, i, l);
}
function x(e, i, l) {
  const { options: a } = e;
  a.field || (a.field = m());
  const r = [
    {
      name: a.field,
      formUid: a.formUid,
      depends: a.depends,
      required: a.required,
      label: a.label,
      sorted_field: a.sorted_field
    }
  ];
  R(r, i, !0), l || J(r, i);
}
function g(e, i, l = !1) {
  const a = [], { type: r } = e, d = l ? e : e.options, t = E(d);
  return w[r] && !l ? w[r].forEach((o) => {
    var f;
    if (typeof d[o] == "object") {
      (f = d[o]) != null && f.field || (d[o].field = m());
      const u = E(d[o]);
      u.depends = d.depends, a.push(...g(u, i, !0));
    }
  }) : (t.name = d.field = d.field || m(), a.push(t)), a;
}
function D(e, i) {
  e.forEach((l) => {
    const { label: a, type: r, name: d, unique: t, spareLabel: o } = l, f = i.fields.findIndex((n) => n.name == d), u = {
      //如果有依赖则为空
      // required: !depends && required,
      required: !1,
      unique: t,
      label: a,
      // 设置的导入导出Excel label
      spareLabel: o,
      type: r,
      name: d
    };
    f == -1 ? i.fields.push(u) : i.fields.splice(f, 1, u);
  });
}
function k(e, i) {
  e.forEach((l) => {
    l.dictRef && (i.dictRefs[l.name] = l.dictRef);
  });
}
function R(e, i, l = !1) {
  e.forEach((r) => {
    a(r, i, l);
  });
  function a(r, d, t) {
    const { name: o, depends: f, required: u, label: n } = r, h = t ? "subform" : "field", V = t ? "subformValidators" : "fieldValidators", F = d.validators[V] || [];
    if (!u)
      d.validators[V] = F.filter((s) => Array.isArray(s.validators) ? s[h] === o ? (s.validators = s.validators.filter(
        ({ type: c }) => c !== "required"
      ), s.validators.length != 0) : !0 : !1);
    else {
      const s = F.find((c) => c[h] === o);
      if (s)
        f && (s.depends = f), n && (s.label = n), Array.isArray(s.validators) ? s.validators.some((L) => L.type === "required") || s.validators.push({ type: "required" }) : s.validators = [{ type: "required" }];
      else {
        const c = { label: n };
        c[h] = o, (f || u) && (f && (c.depends = f), u && (c.validators = [{ type: "required" }]), F.push(c));
      }
    }
  }
}
function J(e, i) {
  e.forEach(({ formUid: l, sorted_field: a }) => {
    const r = {
      name: l,
      fk: "__main_form_record_uid_field__"
    };
    a && (r.sorted_field = a), i.subTables.push(r);
  });
}
function S(e, i) {
  if (i) {
    e.validators || (e.validators = {}), e.validators.fieldValidators || (e.validators.fieldValidators = []), e.validators.subformValidators || (e.validators.subformValidators = []), delete e.validators.subFormValidators;
    return;
  }
  Array.isArray(e.fields) || (e.fields = []), e.subTables = [], e.dictRefs = {}, e.validators || (e.validators = {}), e.validators.fieldValidators || (e.validators.fieldValidators = []), e.validators.subformValidators || (e.validators.subformValidators = []), e.table || (e.table = {}), Array.isArray(e.table.tableFields) || (e.table.tableFields = []), delete e.validators.subFormValidators, T = e.table.tableFields.length == 0;
}
function U(e, i) {
  e.forEach((l) => {
    const { label: a, name: r, type: d } = l;
    i.table.tableFields.push({
      label: a,
      name: r,
      type: d,
      width: 100
    });
  });
}
function W(e, i) {
  if (i || z(e), !e.layout)
    return e;
  S(e, i);
  let l = e.layout;
  return e.layout.children && (l = e.layout.children), _(l, e, i), i || (p == "web" && (e.profile_web = {
    layout: e.layout,
    validators: e.validators
  }), e.profile_mobile && (y = e.fields.map((a) => a.name), W(e.profile_mobile, "app"), b.length > 0 && A.info(
    `app配置字段中 ${b.join(",")} 无法在数据库字段中找到，请修改配置！`
  ), y = [], b = [], p = "")), e;
}
function z(e) {
  e.profile_web && e.profile_mobile || e.profile_web ? (e.layout = e.profile_web.layout, e.validators = e.profile_web.validators, p = "web") : p = "";
}
export {
  w as SPECIAL_TYPE_LIST,
  W as parseJson
};
