const e = [
  {
    operator: "=",
    renderer: {
      type: "TextField",
      options: {
        field: "name",
        label: "规则名称"
      }
    }
  },
  {
    operator: "=",
    renderer: {
      type: "TextField",
      options: {
        field: "rule_value",
        label: "规则值"
      }
    }
  }
], l = [
  { name: "name", label: "规则名称", align: "center" },
  { name: "rule_table", label: "规则表" },
  { name: "rule_column", label: "规则字段", align: "center" },
  { name: "rule_value", label: "规则值", align: "center" },
  {
    name: "rule_conditions",
    label: "条件规则",
    align: "center",
    width: 100
  }
], t = [
  { label: "添加", key: "add", icon: "PlusOutlined" }
], r = [
  { label: "编辑", key: "edit" },
  { label: "删除", key: "delete", color: "#f00", confirm: !0 }
], a = {
  dicts: [
    {
      name: "规则条件",
      type: "enum",
      items: ["<=", "NOT LIKE", "LIKE", "CONTAINS", "<", "!=", "=", ">", ">="]
    }
  ],
  layout: {
    itemOptions: {
      labelSpan: 6,
      wrapperSpan: 18
    },
    children: [
      {
        type: "TextField",
        options: {
          type: "text",
          label: "规则名称",
          required: !0,
          field: "name"
        }
      },
      {
        type: "TextField",
        options: {
          type: "text",
          label: "规则表",
          required: !0,
          readonly: !0,
          field: "rule_table"
        }
      },
      {
        type: "TextField",
        options: {
          type: "text",
          label: "规则字段",
          required: !0,
          field: "rule_column"
        }
      },
      {
        type: "SelectField",
        options: {
          type: "text",
          label: "规则条件",
          required: !0,
          field: "rule_conditions",
          dictRef: "规则条件"
        }
      },
      {
        type: "TextField",
        options: {
          type: "text",
          label: "规则值",
          required: !0,
          field: "rule_value"
        }
      }
    ]
  },
  dictRefs: {
    rule_conditions: "规则条件"
  },
  validators: {
    fieldValidators: [
      {
        label: "规则名称",
        validators: [
          {
            type: "required"
          }
        ],
        field: "name"
      },
      {
        label: "规则字段",
        validators: [
          {
            type: "required"
          }
        ],
        field: "rule_column"
      },
      {
        label: "规则条件",
        validators: [
          {
            type: "required"
          }
        ],
        field: "rule_conditions"
      },
      {
        label: "规则值",
        validators: [
          {
            type: "required"
          }
        ],
        field: "rule_value"
      },
      {
        label: "规则表",
        validators: [
          {
            type: "required"
          }
        ],
        field: "rule_table"
      }
    ],
    subformValidators: []
  }
}, i = {
  提交数据: {
    name: "查看本人提交数据",
    rule_column: "create_by",
    rule_conditions: "=",
    rule_value: "${userId}"
  },
  省级数据: {
    name: "查看省级数据列表",
    rule_column: "省编码",
    rule_conditions: "=",
    rule_value: "${pcode}"
  },
  市级数据: {
    name: "查看市级数据列表",
    rule_column: "市编码",
    rule_conditions: "=",
    rule_value: "${ccode}"
  },
  县级数据: {
    name: "查看县级数据列表",
    rule_column: "县编码",
    rule_conditions: "=",
    rule_value: "${fcode}"
  }
};
export {
  a as formDef,
  i as quickMap,
  r as recordOperators,
  e as searchFields,
  l as tableFields,
  t as tableOperators
};
