import { defineComponent as L, ref as f, onMounted as P, resolveComponent as m, openBlock as C, createElementBlock as j, createElementVNode as y, createVNode as o, withCtx as l, createTextVNode as i, unref as n, isRef as B, createBlock as Q, toDisplayString as _, pushScopeId as W, popScopeId as X } from "vue";
import D from "../../apis/menu/index.ts";
import Y from "./components/MenuInfo/index.vue.ts";
import { Modal as Z, message as R } from "ant-design-vue";
import ee from "../../components/SvgIcon/index.vue.ts";
const q = (v) => (W("data-v-d279e8ef"), v = v(), X(), v), ne = { class: "menu-manage-page" }, te = { class: "left" }, oe = { class: "node-handler" }, le = { class: "right" }, se = /* @__PURE__ */ q(() => /* @__PURE__ */ y("span", null, "菜单选型", -1)), ae = {
  key: 1,
  class: "no-choose-wrap"
}, ie = /* @__PURE__ */ q(() => /* @__PURE__ */ y("p", null, "请选择菜单节点", -1)), de = [
  ie
], me = /* @__PURE__ */ L({
  __name: "index",
  setup(v) {
    const b = f([]);
    let u = f();
    function M(a) {
      for (let t = 0; t < a.length; t++) {
        let e = a[t];
        e.title = `${e.name}(${e.sort_no})`, e.component = e.component.split("/"), e.component[0] === "components" && (e.secondmenu = 1), e.children && M(e.children);
      }
      return a;
    }
    const s = f();
    function A(a, t) {
      t.selected && (s.value = t.node.dataRef);
    }
    function E() {
      Z.confirm({
        title: "删除菜单",
        content: "删除菜单时，对应的子菜单也将删除，确认删除吗？",
        onOk() {
          O(s.value._id);
        },
        onCancel() {
          console.log("Cancel");
        },
        class: "test"
      });
    }
    function O(a) {
      D.deleteMenu(a).then(() => {
        R.success("已删除"), s.value = void 0, g(!1);
      });
    }
    function k(a, t, e = []) {
      for (let c of a)
        c._id === t && e.push(c), c.children && k(c.children, t, e);
      return e;
    }
    async function g(a, t = null) {
      try {
        let e = await D.queryMenuTree();
        if (b.value = M(e), a) {
          d.value = !1;
          let c = k(b.value, t);
          s.value = c[0];
        }
      } catch ({ msg: e }) {
        R.error(e);
      }
    }
    let I = f(), d = f(!1), h = f(""), S = f(!1);
    function w(a) {
      d.value = !0, h.value = a;
    }
    function U() {
      h.value = "edit", d.value = !0;
    }
    function $() {
      d.value = !1;
    }
    async function z() {
      await I.value.onSubmit();
    }
    function F(a) {
      S.value = a;
    }
    return P(async () => {
      g(!0);
    }), (a, t) => {
      var x, T, K, N, V;
      const e = m("a-button"), c = m("a-spin"), G = m("a-drawer"), H = m("a-tree"), p = m("a-descriptions-item"), J = m("a-descriptions");
      return C(), j("div", ne, [
        y("div", te, [
          y("div", oe, [
            o(e, {
              class: "button",
              onClick: t[0] || (t[0] = (r) => w("same")),
              type: "primary"
            }, {
              default: l(() => [
                i("新增同级")
              ]),
              _: 1
            }),
            o(e, {
              class: "button",
              disabled: !!((x = n(s)) != null && x.is_system) || !((T = n(u)) != null && T.length),
              onClick: t[1] || (t[1] = (r) => w("child")),
              type: "primary"
            }, {
              default: l(() => [
                i("新增子级")
              ]),
              _: 1
            }, 8, ["disabled"]),
            o(e, {
              class: "button",
              disabled: !!((K = n(s)) != null && K.is_system) || !((N = n(u)) != null && N.length),
              onClick: E,
              type: "primary",
              danger: ""
            }, {
              default: l(() => [
                i("删除")
              ]),
              _: 1
            }, 8, ["disabled"]),
            o(G, {
              open: n(d),
              "onUpdate:open": t[2] || (t[2] = (r) => B(d) ? d.value = r : d = r),
              class: "custom-class",
              "root-class-name": "root-class-name",
              "root-style": { color: "blue" },
              "footer-style": { display: "flex", "justify-content": "flex-end" },
              title: n(h) === "edit" ? "编辑菜单" : "添加菜单",
              placement: "right",
              destroyOnClose: ""
            }, {
              footer: l(() => [
                o(e, {
                  style: { "margin-right": "8px" },
                  onClick: $
                }, {
                  default: l(() => [
                    i("取消")
                  ]),
                  _: 1
                }),
                o(c, { spinning: n(S) }, {
                  default: l(() => [
                    o(e, {
                      type: "primary",
                      onClick: z
                    }, {
                      default: l(() => [
                        i("确定")
                      ]),
                      _: 1
                    })
                  ]),
                  _: 1
                }, 8, ["spinning"])
              ]),
              default: l(() => [
                o(Y, {
                  onClose: g,
                  ref_key: "menuInfoComponent",
                  ref: I,
                  addMode: n(h),
                  menuInfo: n(s),
                  onSpinning: F
                }, null, 8, ["addMode", "menuInfo"])
              ]),
              _: 1
            }, 8, ["open", "title"])
          ]),
          o(H, {
            selectedKeys: n(u),
            "onUpdate:selectedKeys": t[3] || (t[3] = (r) => B(u) ? u.value = r : u = r),
            "tree-data": n(b),
            onSelect: A
          }, null, 8, ["selectedKeys", "tree-data"])
        ]),
        y("div", le, [
          (V = n(u)) != null && V.length && n(s) ? (C(), Q(J, {
            key: 0,
            column: 1,
            bordered: ""
          }, {
            title: l(() => [
              se,
              o(e, {
                type: "primary",
                onClick: U
              }, {
                default: l(() => [
                  i("修改")
                ]),
                _: 1
              })
            ]),
            default: l(() => [
              o(p, { label: "菜单名称" }, {
                default: l(() => [
                  i(_(n(s).name), 1)
                ]),
                _: 1
              }),
              o(p, { label: "访问路径" }, {
                default: l(() => [
                  i(_(n(s).uri), 1)
                ]),
                _: 1
              }),
              o(p, { label: "显示组件" }, {
                default: l(() => [
                  i(" @/" + _(Array.isArray(n(s).component) ? n(s).component.join("/") : n(s).component), 1)
                ]),
                _: 1
              }),
              o(p, { label: "排序" }, {
                default: l(() => [
                  i(_(n(s).sort_no), 1)
                ]),
                _: 1
              }),
              o(p, { label: "是否显示" }, {
                default: l(() => [
                  i(_(n(s).hide === 0 ? "隐藏" : "显示"), 1)
                ]),
                _: 1
              }),
              o(p, { label: "显示图标" }, {
                default: l(() => [
                  o(ee, {
                    icon: n(s).icon
                  }, null, 8, ["icon"])
                ]),
                _: 1
              })
            ]),
            _: 1
          })) : (C(), j("div", ae, [...de]))
        ])
      ]);
    };
  }
});
export {
  me as default
};
