import { defineComponent as L, ref as r, onMounted as M, resolveComponent as k, openBlock as C, createElementBlock as N, unref as a, createBlock as _, createCommentVNode as z, createVNode as g, isRef as D, withCtx as F } from "vue";
import P from "../../components/GTTable/index.vue.ts";
import { formDef as Q, searchFields as T, tableFields as H, recordOperators as V, tableOperators as j } from "./config.ts";
import v from "../../apis/role/index.ts";
import { cloneDeep as I } from "lodash";
import { message as u } from "ant-design-vue";
import J from "./Permission/index.vue.ts";
const K = {
  class: "page-container",
  ref: "page"
}, re = /* @__PURE__ */ L({
  name: "RoleManage",
  __name: "index",
  setup(W) {
    let y = r(!1), n = r({
      page: 1,
      size: 10
    });
    const s = r(!1), p = r(""), f = r(""), i = r({ formDef: Q, formRecordData: {}, readonlyFields: "" }), O = r();
    let b = r(0);
    const w = r([]), d = async () => {
      y.value = !0;
      try {
        const e = await v.queryAllRole(n.value);
        w.value = e.list, b.value = e.total;
      } catch ({ msg: e }) {
        u.error(e);
      } finally {
        y.value = !1;
      }
    }, S = (e) => {
      const t = {
        page: 1,
        size: 10
      };
      e.length !== 0 && e.forEach((o) => {
        t[o.name] = o.value;
      }), n.value = t, d();
    }, G = (e) => {
      if (!e)
        return;
      const { key: t } = e;
      switch (t) {
        case "add":
          U(t);
          break;
      }
    }, B = (e) => {
      if (!e)
        return;
      const { key: t, data: o } = e;
      switch (t) {
        case "edit":
          $(t, o);
          break;
        case "authorization":
          x(o);
          break;
        case "delete":
          q(o);
          break;
      }
    }, U = (e) => {
      i.value.formRecordData = "", i.value.readonlyFields = "", f.value = e, p.value = "新增", s.value = !0;
    }, $ = (e, t) => {
      f.value = e, p.value = "编辑", s.value = !0, t && (i.value.readonlyFields = "code", i.value.formRecordData = I(t));
    }, m = r(!1), h = r({ name: "", _id: "" }), x = (e) => {
      m.value = !0, h.value = e;
    }, q = async (e) => {
      const { _id: t } = e;
      try {
        await v.deleteRole(t), u.success("删除成功"), await d();
      } catch ({ msg: o }) {
        u.error(o);
      }
    }, A = async () => {
      const e = await O.value.submit(), { data: t, state: o } = e;
      if (o)
        try {
          if (f.value == "add")
            await v.addRole(t);
          else if (f.value == "edit") {
            const { _id: c } = i.value.formRecordData;
            await v.modifyRole(c, t);
          }
          u.success(`${p.value}成功！`), await d(), s.value = !1;
        } catch ({ msg: c }) {
          u.error(c);
        }
    }, E = async () => {
      await d();
    };
    return M(() => {
      d();
    }), (e, t) => {
      const o = k("GTSearch"), c = k("GTForm"), R = k("a-modal");
      return C(), N("div", K, [
        a(T).length != 0 ? (C(), _(o, {
          key: 0,
          fields: a(T),
          onSearch: S
        }, null, 8, ["fields"])) : z("", !0),
        a(H).length != 0 ? (C(), _(P, {
          key: 1,
          data: a(w),
          fields: a(H),
          recordOperators: a(V),
          onRecordOperatorClick: B,
          tableOperators: a(j),
          onTableOperatorClick: G,
          pageCurrent: a(n).page,
          "onUpdate:pageCurrent": t[0] || (t[0] = (l) => a(n).page = l),
          pageSize: a(n).size,
          "onUpdate:pageSize": t[1] || (t[1] = (l) => a(n).size = l),
          total: a(b),
          loading: a(y),
          onRefresh: E,
          allowSelect: !1,
          "y-offset": 310
        }, null, 8, ["data", "fields", "recordOperators", "tableOperators", "pageCurrent", "pageSize", "total", "loading"])) : z("", !0),
        g(R, {
          class: "handler-model",
          getContainer: () => e.$refs.page,
          open: a(s),
          "onUpdate:open": t[2] || (t[2] = (l) => D(s) ? s.value = l : null),
          title: a(p),
          onOk: A,
          destroyOnClose: ""
        }, {
          default: F(() => [
            g(c, {
              ref_key: "gtForm",
              ref: O,
              options: a(i)
            }, null, 8, ["options"])
          ]),
          _: 1
        }, 8, ["getContainer", "open", "title"]),
        g(R, {
          getContainer: () => e.$refs.page,
          open: a(m),
          "onUpdate:open": t[3] || (t[3] = (l) => D(m) ? m.value = l : null),
          title: `角色授权：${a(h).name}`,
          class: "auth-model",
          footer: null,
          width: "90%",
          destroyOnClose: ""
        }, {
          default: F(() => [
            g(J, { data: a(h) }, null, 8, ["data"])
          ]),
          _: 1
        }, 8, ["getContainer", "open", "title"])
      ], 512);
    };
  }
});
export {
  re as default
};
