import { defineComponent as y, ref as i, openBlock as g, createBlock as S, unref as o, isRef as h, readonly as b } from "vue";
import { VAceEditor as C } from "../../../node_modules/vue3-ace-editor/index.ts";
import "../../../node_modules/ace-builds/src-noconflict/mode-json.ts";
import "../../../node_modules/ace-builds/src-noconflict/theme-chrome.ts";
import "../../../node_modules/ace-builds/src-noconflict/theme-eclipse.ts";
import "../../../node_modules/ace-builds/src-noconflict/theme-monokai.ts";
import "../../../node_modules/ace-builds/src-noconflict/ext-language_tools.ts";
import "../../../node_modules/ace-builds/src-noconflict/snippets/json.ts";
import "../../../node_modules/ace-builds/src-noconflict/ext-searchbox.ts";
import "../../../node_modules/ace-builds/src-noconflict/snippets/javascript.ts";
import "../../../node_modules/ace-builds/src-noconflict/mode-javascript.ts";
import "../../../node_modules/ace-builds/src-noconflict/snippets/lua.ts";
import "../../../node_modules/ace-builds/src-noconflict/mode-lua.ts";
import "../../../node_modules/ace-builds/src-noconflict/mode-yaml.ts";
import "../../../node_modules/ace-builds/src-noconflict/mode-less.ts";
const E = /* @__PURE__ */ y({
  name: "AceEditor",
  __name: "index",
  props: {
    readonly: { type: Boolean, required: !1, default: !1 },
    lang: { type: String, required: !1, default: "json" },
    theme: { type: String, required: !1, default: "chrome" }
  },
  emits: ["bindKey"],
  setup(v, { expose: a, emit: l }) {
    const r = i(), s = i(), m = {
      enableBasicAutocompletion: !0,
      //启用基本自动完成
      enableSnippets: !0,
      // 启用代码段
      enableLiveAutocompletion: !0,
      //启用实时自动完成
      tabSize: 2,
      //标签大小
      fontSize: 14,
      //设置字号
      showPrintMargin: !1
      //去除编辑器里的竖线
    }, p = l, d = () => c(r.value) ? { state: !0, data: JSON.parse(r.value) } : { state: !1, data: null }, f = (e) => {
      typeof e != "object" && e !== void 0 && (e = JSON.parse(e));
      try {
        e = JSON.stringify(e, null, 2);
      } catch (t) {
        console.log("error :>> ", t);
      }
      r.value = e;
    }, u = (e) => {
      e.resize(), e.commands.addCommand({
        name: "myCommand",
        bindKey: { win: "Ctrl-S", mac: "Command-S" },
        exec: function(t) {
          p("bindKey", "Ctrl-S"), t.findNext(), t.findPrevious();
        }
      });
    };
    function c(e) {
      if (typeof e == "string")
        try {
          var t = JSON.parse(e);
          return !!(typeof t == "object" && t);
        } catch {
          return !1;
        }
    }
    return a({ setValue: f, getValue: d }), (e, t) => (g(), S(o(C), {
      ref_key: "editor",
      ref: s,
      value: o(r),
      "onUpdate:value": t[0] || (t[0] = (n) => h(r) ? r.value = n : null),
      onInit: u,
      lang: e.lang,
      theme: e.theme,
      options: m,
      readonly: "readonly" in e ? e.readonly : o(b),
      style: { height: "100%" },
      class: "ace-editor edit-max"
    }, null, 8, ["value", "lang", "theme", "readonly"]));
  }
});
export {
  E as default
};
