import i from "../calculator/Factory.ts";
import c from "./Validator.ts";
class m extends c {
  constructor(r, a, s) {
    super(r, a, s);
  }
  /**
   * 生成校验规则
   */
  getRule() {
    const { expression: r, message: a } = this.def.options || {};
    if (!r || !Array.isArray(r) || r.length < 3)
      return;
    const s = r[0], o = r[1], u = r[2];
    return {
      message: a || `请输入正确的${this.fieldLabel}`,
      validator: () => {
        const e = this.getValue(o), t = this.getValue(u);
        if (isNaN(e) && isNaN(t) && s === "==")
          return e == t;
        if (isNaN(e) || isNaN(t))
          return !0;
        switch (s) {
          case ">=":
            return e >= t;
          case ">":
            return e > t;
          case "==":
            return e == t;
          case "<=":
            return e <= t;
          case "<":
            return e < t;
          case "!=":
            return e != t;
        }
      }
    };
  }
  getValue(r) {
    if (r) {
      if (Array.isArray(r)) {
        const a = i.createCalculator(r, this.formData);
        return a ? a.calc() : void 0;
      }
      return this.formData[r];
    }
  }
}
export {
  m as default
};
