import { defineComponent as $, computed as i, ref as u, onMounted as ee, resolveComponent as h, openBlock as le, createElementBlock as oe, Fragment as ne, createVNode as s, unref as d, withCtx as x, createElementVNode as k, isRef as w, h as ae, createTextVNode as z } from "vue";
import te from "../../BaseFields/index.ts";
import { EnvironmentOutlined as ie } from "@ant-design/icons-vue";
import { message as de } from "ant-design-vue";
import ue from "./Amap/index.vue.ts";
const se = { class: "gt-lonLat-box" }, re = { class: "map-box" }, ce = { class: "btn-box" }, be = /* @__PURE__ */ $({
  name: "LonLatField",
  __name: "index",
  props: {
    options: { type: Object, required: !0 },
    formData: { type: Object, required: !0 }
  },
  setup(G) {
    const n = G, { label: R, required: I, readonly: M, hide: J, eventBus: f, formRecordData: H } = te(n), q = i(() => n.options.precision || 6), m = i(() => n.options.latField.field).value, F = i(() => n.options.lonField.field).value, B = i(() => n.options.zeroFill), V = i(() => {
      var e;
      return (e = n.options.pcodeField) == null ? void 0 : e.field;
    }), D = i(() => {
      var e;
      return (e = n.options.pnameField) == null ? void 0 : e.field;
    }), O = i(() => {
      var e;
      return (e = n.options.ccodeField) == null ? void 0 : e.field;
    }), A = i(() => {
      var e;
      return (e = n.options.cnameField) == null ? void 0 : e.field;
    }), E = i(() => {
      var e;
      return (e = n.options.fcodeField) == null ? void 0 : e.field;
    }), S = i(() => {
      var e;
      return (e = n.options.fnameField) == null ? void 0 : e.field;
    }), T = i(() => {
      var e;
      return (e = n.options.addressField) == null ? void 0 : e.field;
    }), r = u(), c = u(), v = u(!1), K = () => {
      v.value = !0;
    }, U = u(!1), P = (e) => {
      U.value = e;
    }, b = u(), _ = u(), C = u(""), g = u(), Q = (e, o, a, p) => {
      b.value = e, _.value = o, C.value = a, g.value = p;
    }, L = () => {
      b.value = void 0, _.value = void 0, C.value = "", g.value = void 0;
    }, W = () => {
      if (!b.value || !_.value) {
        de.warning("请选择点位");
        return;
      }
      r.value = Number(b.value.toFixed(q.value)), c.value = Number(_.value.toFixed(q.value)), f.emit("change", { field: F, value: r.value }), f.emit("change", { field: m, value: c.value }), X(), v.value = !1, L();
    }, X = () => {
      if (!g.value)
        return;
      const { provinceName: e, provinceCode: o, countyName: a, countyCode: p, cityName: N, cityCode: y } = g.value;
      l(V.value, B.value ? o : o.slice(0, 2)), l(E.value, p), l(D.value, e), l(A.value, N), l(S.value, a), l(T.value, C.value);
      let t = B.value ? y : y.slice(0, 4);
      t === "5002" && (t = "5001"), t === "500200" && (t = "500100"), l(O.value, t);
    }, l = (e, o) => {
      e && f.emit("change", { field: e, value: o });
    }, Y = () => {
      r.value = void 0, c.value = void 0, l(F, void 0), l(m, void 0), l(V.value, void 0), l(E.value, void 0), l(D.value, void 0), l(A.value, void 0), l(S.value, void 0), l(T.value, void 0), l(O.value, void 0), v.value = !1, L();
    }, Z = () => {
      L(), v.value = !1;
    };
    ee(() => {
      !F || !m || (j(F, r), j(m, c));
    });
    const j = (e, o) => {
      let a = null;
      [void 0, null, ""].includes(H[e]) || (a = H[e]), a !== null && (o.value = a, f.emit("change", { field: e, value: a }));
    };
    return (e, o) => {
      const a = h("a-input-number"), p = h("a-button"), N = h("GTField"), y = h("a-drawer");
      return le(), oe(ne, null, [
        s(N, {
          label: d(R),
          field: d(m),
          required: d(I),
          hide: d(J)
        }, {
          default: x(() => [
            k("div", se, [
              s(a, {
                class: "form-item",
                value: d(r),
                "onUpdate:value": o[0] || (o[0] = (t) => w(r) ? r.value = t : null),
                placeHolder: "请输入经度",
                disabled: ""
              }, null, 8, ["value"]),
              s(a, {
                class: "form-item",
                value: d(c),
                "onUpdate:value": o[1] || (o[1] = (t) => w(c) ? c.value = t : null),
                placeHolder: "请输入纬度",
                disabled: ""
              }, null, 8, ["value"]),
              s(p, {
                disabled: d(M),
                type: "primary",
                icon: ae(d(ie)),
                onClick: K
              }, null, 8, ["disabled", "icon"])
            ])
          ]),
          _: 1
        }, 8, ["label", "field", "required", "hide"]),
        s(y, {
          class: "drawer-box",
          width: "80%",
          title: "在线地图",
          destroyOnClose: "",
          open: d(v),
          "onUpdate:open": o[2] || (o[2] = (t) => w(v) ? v.value = t : null),
          placement: "right",
          headerStyle: { textAlign: "center" },
          bodyStyle: { padding: "20px" },
          onClose: Z
        }, {
          default: x(() => [
            k("div", re, [
              s(ue, {
                ref: "map",
                onLoading: P,
                onChange: Q
              }, null, 512)
            ]),
            k("div", ce, [
              s(p, {
                style: { "margin-right": "8px" },
                onClick: Y
              }, {
                default: x(() => [
                  z("清空")
                ]),
                _: 1
              }),
              s(p, {
                type: "primary",
                loading: d(U),
                onClick: W
              }, {
                default: x(() => [
                  z("确定")
                ]),
                _: 1
              }, 8, ["loading"])
            ])
          ]),
          _: 1
        }, 8, ["open"])
      ], 64);
    };
  }
});
export {
  be as default
};
