import { defineComponent as V, ref as v, onMounted as w, resolveComponent as s, openBlock as p, createBlock as h, unref as r, withCtx as f, createVNode as D, isRef as T, createElementBlock as j, Fragment as G, renderList as N, createTextVNode as O, toDisplayString as R } from "vue";
import E from "../../BaseFields/index.ts";
import { parseDict as H } from "../../../../utils/dict.ts";
import { keyBy as L } from "lodash";
const P = /* @__PURE__ */ V({
  name: "RadioField",
  __name: "index",
  props: {
    options: { type: Object, required: !0 },
    formData: { type: Object, required: !0 }
  },
  setup(y, { expose: g }) {
    const m = y, { label: b, field: i, required: x, readonly: B, placeholder: q, inputValue: o, hide: F, eventBus: k } = E(m), d = v([]), u = v({}), A = () => {
      c(o.value);
    };
    w(() => {
      C();
    });
    async function C() {
      const { dict: e } = m.options;
      d.value = await H(e), u.value = _(d.value);
    }
    function _(e) {
      let t = L(e, "value");
      if (Array.isArray(e) && e.length > 0)
        for (let a = 0; a < e.length; a++) {
          const { children: l } = e[a];
          l && (t = { ...t, ..._(l) });
        }
      return t;
    }
    function c(e) {
      o.value = e;
      let t = [];
      Array.isArray(e) && (t = e.map((a) => {
        var l;
        return ((l = u.value[a]) == null ? void 0 : l.data) || u.value[a];
      })), k.emit("change", { field: i, value: e, data: t });
    }
    return g({ reset: () => {
      c(null);
    }, field: i, setValue: c }), (e, t) => {
      const a = s("a-radio"), l = s("a-radio-group"), I = s("GTField");
      return p(), h(I, {
        label: r(b),
        field: r(i),
        required: r(x),
        hide: r(F)
      }, {
        default: f(() => [
          D(l, {
            value: r(o),
            "onUpdate:value": t[0] || (t[0] = (n) => T(o) ? o.value = n : null),
            placeholder: r(q),
            onChange: A,
            "allow-clear": "",
            disabled: r(B)
          }, {
            default: f(() => [
              (p(!0), j(G, null, N(r(d), (n, M) => (p(), h(a, {
                value: n.value,
                key: M
              }, {
                default: f(() => [
                  O(R(n.label), 1)
                ]),
                _: 2
              }, 1032, ["value"]))), 128))
            ]),
            _: 1
          }, 8, ["value", "placeholder", "disabled"])
        ]),
        _: 1
      }, 8, ["label", "field", "required", "hide"]);
    };
  }
});
export {
  P as default
};
