import { defineComponent as H, computed as r, ref as w, onMounted as L, nextTick as P, watch as R, resolveComponent as _, openBlock as d, createBlock as g, unref as l, withCtx as f, createElementVNode as U, createVNode as J, isRef as K, createCommentVNode as Q, createElementBlock as W, Fragment as X, renderList as Y, createTextVNode as Z, toDisplayString as $ } from "vue";
import ee from "../../BaseFields/index.ts";
import te from "../../../SvgIcon/index.vue.ts";
import { getFilter as le, getAllItems as oe } from "./utils.ts";
import { isEqual as ae } from "lodash";
const re = { class: "select-wrap" }, de = /* @__PURE__ */ H({
  name: "SelectField",
  __name: "index",
  props: {
    options: { type: Object, required: !0 },
    formData: { type: Object, required: !0 }
  },
  setup(x, { expose: I }) {
    const o = x, { label: k, field: u, required: q, readonly: A, placeholder: B, inputValue: a, hide: S, reset: E, eventBus: b } = ee(o), N = r(() => o.options.mode), y = r(() => o.options.unit), T = r(() => !o.options.hideClear), V = r(() => !!o.options.showSearch), D = r(() => o.options.filter).value, M = r(() => o.options.lazy).value;
    let c = w(void 0), p = w({});
    const { filterField: m, focusField: v } = le(D), h = r(() => v ? o.formData[v] : void 0), C = r(() => {
      if (c.value !== void 0)
        return !M && m ? h.value !== void 0 ? c.value.filter((e) => e.data[m] === h.value) : [] : c.value;
    });
    b.on("change", z), L(async () => {
      await F();
    });
    const F = async () => {
      const { getItems: e, getItemsMap: t } = await oe(o.options, h.value);
      c.value = e, p.value = t;
    }, j = () => {
      n(a.value);
    }, n = (e) => {
      let t;
      e && (Array.isArray(e) ? t = e.map((i) => p.value[i].data) : t = p.value[e].data), a.value = e, b.emit("change", { field: u, value: e, data: l(t) });
    };
    function z(e) {
      if (e.field === u && !ae(e.value, a.value)) {
        P(() => {
          n(e.value);
        });
        return;
      }
      !m || v !== e.field || F();
    }
    return R(
      () => C.value,
      (e) => {
        if (e !== void 0)
          if (e.length === 0)
            n(void 0);
          else if (Array.isArray(a.value)) {
            let t = [];
            e.forEach((i) => {
              a.value.includes(i.value) && t.push(i.value);
            }), t.length === 0 && (t = void 0), n(t);
          } else
            e.some((t) => t.value == a.value) || n(void 0);
      }
    ), I({ reset: E, field: u, setValue: n }), (e, t) => {
      const i = _("a-select-option"), G = _("a-select"), O = _("GTField");
      return d(), g(O, {
        label: l(k),
        field: l(u),
        required: l(q),
        hide: l(S)
      }, {
        default: f(() => [
          U("div", re, [
            J(G, {
              mode: l(N),
              value: l(a),
              "onUpdate:value": t[0] || (t[0] = (s) => K(a) ? a.value = s : null),
              placeholder: l(B),
              onChange: j,
              "allow-clear": l(T),
              "show-search": l(V),
              optionFilterProp: "label",
              disabled: l(A)
            }, {
              suffixIcon: f(() => [
                l(y) ? (d(), g(te, {
                  key: 0,
                  icon: l(y)
                }, null, 8, ["icon"])) : Q("", !0)
              ]),
              default: f(() => [
                (d(!0), W(X, null, Y(l(C), (s) => (d(), g(i, {
                  key: s.value,
                  label: s.label,
                  title: s.label
                }, {
                  default: f(() => [
                    Z($(s.label), 1)
                  ]),
                  _: 2
                }, 1032, ["label", "title"]))), 128))
              ]),
              _: 1
            }, 8, ["mode", "value", "placeholder", "allow-clear", "show-search", "disabled"])
          ])
        ]),
        _: 1
      }, 8, ["label", "field", "required", "hide"]);
    };
  }
});
export {
  de as default
};
