import { defineComponent as g, useModel as C, ref as p, reactive as b, resolveComponent as n, openBlock as k, createElementBlock as q, createVNode as a, unref as r, withCtx as l } from "vue";
import M from "../apis/user/index.ts";
import { message as w } from "ant-design-vue";
import x from "../common/logout.ts";
const U = { class: "password-modify" }, B = /* @__PURE__ */ g({
  name: "PasswordModify",
  __name: "PasswordModify",
  props: {
    open: {},
    openModifiers: {}
  },
  emits: ["update:open"],
  setup(c) {
    const t = C(c, "open"), f = p(), d = p(!1), o = b({
      confirmPassword: "",
      newPassword: "",
      oldPassword: ""
    }), v = {
      newPassword: [
        {
          trigger: "blur",
          required: !0,
          message: "请输入新密码"
        }
        // {
        //   trigger: 'blur',
        //   pattern: /^.*(?=.{6,16})(?=.*\d)(?=.*[A-Z])(?=.*[a-z]).*$/,
        //   message: '密码6到16位，包含数字和大小写字母'
        // }
      ],
      confirmPassword: [{ validator: async (i, e) => e === "" ? Promise.reject("请输入确认密码") : e !== o.newPassword ? Promise.reject("两次输入密码不一致") : Promise.resolve(), trigger: "change" }]
    }, P = () => {
      f.value.validate().then(async () => {
        try {
          d.value = !0, await M.userModifyPassword(o), w.success("修改成功！"), x(), t.value = !1;
        } catch (i) {
          w.error(i.msg);
        } finally {
          d.value = !1;
        }
      });
    };
    return (i, e) => {
      const m = n("a-input-password"), u = n("a-form-item"), _ = n("a-form"), y = n("a-modal");
      return k(), q("div", U, [
        a(y, {
          destroyOnClose: "",
          maskClosable: !1,
          getContainer: ".password-modify",
          class: "modify-model",
          open: t.value,
          "onUpdate:open": e[3] || (e[3] = (s) => t.value = s),
          title: "修改密码",
          style: { width: "500px" },
          confirmLoading: r(d),
          onOk: P
        }, {
          default: l(() => [
            a(_, {
              ref_key: "formRef",
              ref: f,
              name: "custom-validation",
              model: r(o),
              rules: v,
              "label-col": { span: 6 },
              "wrapper-col": { span: 18 }
            }, {
              default: l(() => [
                a(u, {
                  label: "旧密码",
                  name: "oldPassword",
                  required: ""
                }, {
                  default: l(() => [
                    a(m, {
                      allowClear: "",
                      value: r(o).oldPassword,
                      "onUpdate:value": e[0] || (e[0] = (s) => r(o).oldPassword = s),
                      type: "password",
                      placeholder: "请输入旧密码"
                    }, null, 8, ["value"])
                  ]),
                  _: 1
                }),
                a(u, {
                  label: "新密码",
                  name: "newPassword",
                  required: ""
                }, {
                  default: l(() => [
                    a(m, {
                      allowClear: "",
                      value: r(o).newPassword,
                      "onUpdate:value": e[1] || (e[1] = (s) => r(o).newPassword = s),
                      placeholder: "请输入新密码",
                      type: "password"
                    }, null, 8, ["value"])
                  ]),
                  _: 1
                }),
                a(u, {
                  label: "确认密码",
                  name: "confirmPassword",
                  autocomplete: "off",
                  required: ""
                }, {
                  default: l(() => [
                    a(m, {
                      allowClear: "",
                      value: r(o).confirmPassword,
                      "onUpdate:value": e[2] || (e[2] = (s) => r(o).confirmPassword = s),
                      placeholder: "请输入确认密码"
                    }, null, 8, ["value"])
                  ]),
                  _: 1
                })
              ]),
              _: 1
            }, 8, ["model"])
          ]),
          _: 1
        }, 8, ["open", "confirmLoading"])
      ]);
    };
  }
});
export {
  B as default
};
