import { defineComponent as j, mergeModels as C, useModel as q, ref as m, onMounted as N, resolveComponent as g, openBlock as _, createElementBlock as F, createElementVNode as f, createVNode as n, unref as k, createBlock as A, withCtx as i, createTextVNode as l } from "vue";
import { message as a } from "ant-design-vue";
import { parseJson as c } from "../../../../utils/json.ts";
import D from "../../../../apis/formDesign/index.ts";
const G = { class: "max" }, I = { class: "content-box" }, J = {
  key: 1,
  class: "form-box"
}, L = { class: "footer-box" }, h = /* @__PURE__ */ j({
  name: "FormDesignEditor",
  __name: "index",
  props: /* @__PURE__ */ C({
    type: { type: String, required: !0 },
    data: { type: null, required: !0 }
  }, {
    open: {},
    openModifiers: {}
  }),
  emits: /* @__PURE__ */ C(["getList"], ["update:open"]),
  setup(V, { emit: $ }) {
    const b = q(V, "open"), p = V, E = $, o = m(), x = m(), v = m(!1);
    let r = "";
    const w = m({
      formDef: {}
    });
    N(() => {
      p.type === "add" ? (o.value.setValue({
        name: "",
        title: "",
        description: "",
        dicts: [],
        layout: [],
        fields: [],
        table: {
          searchItems: [
            {
              operator: "=",
              renderer: {
                type: "TextField",
                options: {
                  field: "test",
                  label: "搜索条件"
                }
              }
            }
          ],
          tableFields: [
            {
              label: "_id",
              name: "_id"
            }
          ]
        }
      }), r = "") : (o.value.setValue(p.data), r = p.data.name);
    });
    async function M() {
      const t = o.value.getValue();
      if (!t.state) {
        a.warning("请输入正确的json格式表单！");
        return;
      }
      const e = c(t.data);
      if (!e.name) {
        a.warning("表单name不能为空！");
        return;
      }
      try {
        r ? await D.updateFormDesign(r, e) : await D.addFormDesign(e), a.success(`${r ? "编辑" : "添加"}成功！`), b.value = !1, E("getList");
      } catch (d) {
        a.error(d.msg);
      }
    }
    function B(t) {
      if (!t) {
        const e = o.value.getValue();
        if (!e.state) {
          a.warning("请输入正确的json格式表单！");
          return;
        }
        w.value.formDef = c(e.data);
      }
      v.value = !t;
    }
    function y(t = !1) {
      const e = o.value.getValue();
      if (!e.state) {
        a.warning("请输入正确的json格式表单！");
        return;
      }
      t ? o.value.setValue(c(e.data)) : x.value.setValue(c(e.data));
    }
    return (t, e) => {
      const d = g("AceEditor"), T = g("GTForm"), s = g("a-button");
      return _(), F("div", G, [
        f("div", I, [
          n(d, {
            class: "ace-editor",
            onBindKey: e[0] || (e[0] = (u) => y()),
            ref_key: "editor1",
            ref: o
          }, null, 512),
          k(v) ? (_(), F("div", J, [
            n(T, { options: k(w) }, null, 8, ["options"])
          ])) : (_(), A(d, {
            key: 0,
            class: "ace-editor",
            ref_key: "editor2",
            ref: x,
            theme: "monokai",
            readonly: ""
          }, null, 512))
        ]),
        f("div", L, [
          f("div", null, [
            n(s, {
              type: "primary",
              onClick: e[1] || (e[1] = (u) => y())
            }, {
              default: i(() => [
                l("点击验证")
              ]),
              _: 1
            }),
            n(s, {
              type: "primary",
              onClick: e[2] || (e[2] = (u) => B(k(v)))
            }, {
              default: i(() => [
                l("切换视图")
              ]),
              _: 1
            }),
            n(s, {
              type: "primary",
              onClick: e[3] || (e[3] = (u) => y(!0))
            }, {
              default: i(() => [
                l("格式化")
              ]),
              _: 1
            })
          ]),
          f("div", null, [
            n(s, {
              onClick: e[4] || (e[4] = (u) => b.value = !1)
            }, {
              default: i(() => [
                l("取消")
              ]),
              _: 1
            }),
            n(s, {
              type: "primary",
              onClick: M
            }, {
              default: i(() => [
                l("确定")
              ]),
              _: 1
            })
          ])
        ])
      ]);
    };
  }
});
export {
  h as default
};
