import * as d from "../../../../App.vue.ts";
import * as a from "../../../../app/views/FormTest/index.vue.ts";
import * as c from "../../../../components/AceEditor/index.vue.ts";
import * as p from "../../../../components/GTSearch/index.vue.ts";
import * as u from "../../../../components/GTSearchTable/index.vue.ts";
import * as f from "../../../../components/GTTable/index.vue.ts";
import * as l from "../../../../components/ResourceTable/index.vue.ts";
import * as x from "../../../../components/SvgIcon/index.vue.ts";
import * as v from "../../../../components/form/GTField/index.vue.ts";
import * as $ from "../../../../components/form/GTForm/index.vue.ts";
import * as F from "../../../../components/form/Layout/Card/index.vue.ts";
import * as y from "../../../../components/form/Layout/Grid/index.vue.ts";
import * as b from "../../../../components/form/Layout/Group/index.vue.ts";
import * as g from "../../../../components/form/Layout/SplitLine/index.vue.ts";
import * as w from "../../../../components/form/Layout/Title/index.vue.ts";
import * as R from "../../../../components/form/field/CascaderField/index.vue.ts";
import * as h from "../../../../components/form/field/CheckboxField/index.vue.ts";
import * as M from "../../../../components/form/field/DateField/index.vue.ts";
import * as L from "../../../../components/form/field/DateRangeField/index.vue.ts";
import * as S from "../../../../components/form/field/FileField/index.vue.ts";
import * as T from "../../../../components/form/field/LonLatField/Amap/index.vue.ts";
import * as P from "../../../../components/form/field/LonLatField/index.vue.ts";
import * as D from "../../../../components/form/field/LonLatInputField/InputNumber.vue.ts";
import * as A from "../../../../components/form/field/LonLatInputField/index.vue.ts";
import * as N from "../../../../components/form/field/NumberField/index.vue.ts";
import * as G from "../../../../components/form/field/NumberWithUnitField/index.vue.ts";
import * as q from "../../../../components/form/field/PictureField/index.vue.ts";
import * as C from "../../../../components/form/field/RadioField/index.vue.ts";
import * as I from "../../../../components/form/field/SelectField/index.vue.ts";
import * as E from "../../../../components/form/field/SubForm/SubFormTable.vue.ts";
import * as k from "../../../../components/form/field/SubForm/index.vue.ts";
import * as B from "../../../../components/form/field/TextField/index.vue.ts";
import * as j from "../../../../components/form/field/YearSelectField/index.vue.ts";
import * as U from "../../../../components/form/field/iconField/components/ant.vue.ts";
import * as W from "../../../../components/form/field/iconField/components/iconfont.vue.ts";
import * as O from "../../../../components/form/field/iconField/index.vue.ts";
import * as z from "../../../../layout/MenuBar.vue.ts";
import * as H from "../../../../layout/NavBar.vue.ts";
import * as J from "../../../../layout/PasswordModify.vue.ts";
import * as K from "../../../../layout/SubMenu.vue.ts";
import * as V from "../../../FormDesign/components/FormAuth/index.vue.ts";
import * as Y from "../../../FormDesign/components/FormDesignEditor/index.vue.ts";
import * as _ from "../../../FormDesign/components/FormRule/index.vue.ts";
import * as Q from "../../../FormDesign/index.vue.ts";
import * as X from "../../../FormPage/index.vue.ts";
import * as Z from "../../../Login/components/Register/index.vue.ts";
import * as ee from "../../../Login/components/ResetPasswd/index.vue.ts";
import * as oe from "../../../Login/components/Signing/index.vue.ts";
import * as ie from "../../../Login/index.vue.ts";
import * as ne from "./index.vue.ts";
import * as re from "../../index.vue.ts";
import * as se from "../../../NotFound/index.vue.ts";
import * as te from "../../../RoleManage/Permission/components/AuthorApi/index.vue.ts";
import * as me from "../../../RoleManage/Permission/components/Menu/index.vue.ts";
import * as de from "../../../RoleManage/Permission/components/Resources/ModifyResource.vue.ts";
import * as ae from "../../../RoleManage/Permission/components/Resources/Rule.vue.ts";
import * as ce from "../../../RoleManage/Permission/components/Resources/index.vue.ts";
import * as pe from "../../../RoleManage/Permission/index.vue.ts";
import * as ue from "../../../RoleManage/index.vue.ts";
import * as fe from "../../../UserManage/components/Form/index.vue.ts";
import * as le from "../../../UserManage/index.vue.ts";
import * as xe from "../../../Workspace.vue.ts";
const ve = [
  {
    name: "hideshow",
    type: "inline",
    items: [
      {
        label: "显示",
        value: 1
      },
      {
        label: "隐藏",
        value: 0
      }
    ]
  },
  {
    name: "yn",
    type: "inline",
    items: [
      {
        label: "是",
        value: 1
      },
      {
        label: "否",
        value: 0
      }
    ]
  },
  {
    name: "componenturi",
    type: "inline",
    items: we()
  }
], $e = {
  hide: "hideshow",
  component: "componenturi",
  secondmenu: "yn"
}, Fe = {
  children: [
    {
      type: "TextField",
      options: {
        type: "text",
        field: "name",
        label: "菜单名称",
        required: !0
      }
    },
    {
      type: "TextField",
      options: {
        type: "text",
        field: "uri",
        label: "访问路径",
        required: !0
      }
    },
    {
      type: "RadioField",
      options: {
        type: "text",
        field: "secondmenu",
        label: "是否为二级菜单",
        default: 0,
        dictRef: "yn",
        required: !0
      }
    },
    {
      type: "CascaderField",
      options: {
        type: "text",
        field: "component",
        label: "显示组件",
        required: !0,
        dictRef: "componenturi",
        depends: ["==", "secondmenu", 0]
      }
    },
    {
      type: "iconField",
      options: {
        type: "text",
        field: "icon",
        label: "显示图标"
      }
    },
    {
      type: "NumberField",
      options: {
        type: "text",
        field: "sort_no",
        label: "排序",
        required: !0
      }
    },
    {
      type: "RadioField",
      options: {
        type: "number",
        field: "hide",
        label: "是否显示",
        dictRef: "hideshow",
        required: !0,
        default: 1
      }
    }
  ]
}, ye = {
  fieldValidators: [
    {
      field: "name",
      label: "菜单名称",
      validators: [
        {
          type: "regex",
          options: {
            pattern: /^\S+$/,
            message: "菜单名称不能包含空格"
          }
        }
      ]
    },
    {
      field: "uri",
      label: "访问路径",
      validators: [
        {
          type: "regex",
          options: {
            pattern: /^\S+$/,
            message: "访问路径不能包含空格"
          }
        }
      ]
    }
  ]
}, be = {
  layout: Fe,
  dicts: ve,
  dictRefs: $e,
  validators: ye
}, Re = {
  formDef: be,
  formRecordData: {}
};
function ge(n) {
  return Object.keys(/* @__PURE__ */ Object.assign({ "/src/App.vue": d, "/src/app/views/FormTest/index.vue": a, "/src/components/AceEditor/index.vue": c, "/src/components/GTSearch/index.vue": p, "/src/components/GTSearchTable/index.vue": u, "/src/components/GTTable/index.vue": f, "/src/components/ResourceTable/index.vue": l, "/src/components/SvgIcon/index.vue": x, "/src/components/form/GTField/index.vue": v, "/src/components/form/GTForm/index.vue": $, "/src/components/form/Layout/Card/index.vue": F, "/src/components/form/Layout/Grid/index.vue": y, "/src/components/form/Layout/Group/index.vue": b, "/src/components/form/Layout/SplitLine/index.vue": g, "/src/components/form/Layout/Title/index.vue": w, "/src/components/form/field/CascaderField/index.vue": R, "/src/components/form/field/CheckboxField/index.vue": h, "/src/components/form/field/DateField/index.vue": M, "/src/components/form/field/DateRangeField/index.vue": L, "/src/components/form/field/FileField/index.vue": S, "/src/components/form/field/LonLatField/Amap/index.vue": T, "/src/components/form/field/LonLatField/index.vue": P, "/src/components/form/field/LonLatInputField/InputNumber.vue": D, "/src/components/form/field/LonLatInputField/index.vue": A, "/src/components/form/field/NumberField/index.vue": N, "/src/components/form/field/NumberWithUnitField/index.vue": G, "/src/components/form/field/PictureField/index.vue": q, "/src/components/form/field/RadioField/index.vue": C, "/src/components/form/field/SelectField/index.vue": I, "/src/components/form/field/SubForm/SubFormTable.vue": E, "/src/components/form/field/SubForm/index.vue": k, "/src/components/form/field/TextField/index.vue": B, "/src/components/form/field/YearSelectField/index.vue": j, "/src/components/form/field/iconField/components/ant.vue": U, "/src/components/form/field/iconField/components/iconfont.vue": W, "/src/components/form/field/iconField/index.vue": O, "/src/layout/MenuBar.vue": z, "/src/layout/NavBar.vue": H, "/src/layout/PasswordModify.vue": J, "/src/layout/SubMenu.vue": K, "/src/views/FormDesign/components/FormAuth/index.vue": V, "/src/views/FormDesign/components/FormDesignEditor/index.vue": Y, "/src/views/FormDesign/components/FormRule/index.vue": _, "/src/views/FormDesign/index.vue": Q, "/src/views/FormPage/index.vue": X, "/src/views/Login/components/Register/index.vue": Z, "/src/views/Login/components/ResetPasswd/index.vue": ee, "/src/views/Login/components/Signing/index.vue": oe, "/src/views/Login/index.vue": ie, "/src/views/MenuManage/components/MenuInfo/index.vue": ne, "/src/views/MenuManage/index.vue": re, "/src/views/NotFound/index.vue": se, "/src/views/RoleManage/Permission/components/AuthorApi/index.vue": te, "/src/views/RoleManage/Permission/components/Menu/index.vue": me, "/src/views/RoleManage/Permission/components/Resources/ModifyResource.vue": de, "/src/views/RoleManage/Permission/components/Resources/Rule.vue": ae, "/src/views/RoleManage/Permission/components/Resources/index.vue": ce, "/src/views/RoleManage/Permission/index.vue": pe, "/src/views/RoleManage/index.vue": ue, "/src/views/UserManage/components/Form/index.vue": fe, "/src/views/UserManage/index.vue": le, "/src/views/Workspace.vue": xe })).map((e) => {
    const o = e.replace("./", "").split("/");
    return o.splice(0, 2), o;
  }).filter((e) => n.includes(e[0]) && e.length > 1 && !e.includes("components"));
}
function we() {
  const n = ge(["app", "views", "pages"]), r = [];
  return n.forEach((s) => {
    let e = r;
    s.forEach((o, m) => {
      const t = e.find((i) => i.value === o);
      if (t)
        e = t.children || (t.children = []);
      else {
        const i = { value: o, label: o };
        e.push(i), e = i.children || (i.children = []), m === s.length - 1 && delete i.children;
      }
    });
  }), r;
}
export {
  Re as options
};
